/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.2c Standard
Automatic Program Generator
 Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : --  13- 7- 
Version : 1.00
Date    : 26.10.2006
Author  : Pavel                           
Company :                                 
Comments: 


Chip type           : ATmega162
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega162.h>
#include <stdio.h>
#include <delay.h>
#include <string.h>

#include "rtc.h"

// 
#define ALARM_LED		PORTD.7  
#define BEEPER_PIN		PORTE.2

//       
//  == 0 -  
//  == 1 -  
#define NO_POWER_PIN		PINE.0
                                       
//        
// Mode - PINB.0
#define BUTTON_MODE		PINB.0
// Correction - PINB.1
#define BUTTON_CORR		PINB.1
// Down - PINB.2
#define BUTTON_DOWN		PINB.2
// Up - PINB.3
#define BUTTON_UP		PINB.3
// Set - PINB.4
#define BUTTON_SET		PINB.4

//   
//  1: "DD.MM hh-mm-ss"
#define MODE_1		0x01
//  2: "DD  d hh-mm-ss"
#define MODE_2		0x02
//  3: "DD.MM d  hh-mm"  
#define MODE_3		0x04
//  4: "DD.MM.d.hh-mm-ss"
#define MODE_4		0x08
//  5: "DD.MM.YYYY hh.mm"  
#define MODE_5		0x10
//  6: "d  hh - mm"  
#define MODE_6		0x20

//  
#define CORR_CLOCK_SEC		0x01
#define CORR_CLOCK_MIN		0x02
#define CORR_CLOCK_HOUR		0x04
#define CORR_CALENDAR_DAY	0x08
#define CORR_CALENDAR_MONTH	0x10
#define CORR_CALENDAR_YEAR	0x20
#define CORR_ALARM_MIN		0x40
#define CORR_ALARM_HOUR		0x80

// Declare your global variables here
void cpuInit ( void );
void portsInit ( void );
//     
void timer0Init ( void );
//    
void timer0off ( void );

volatile dword ms = 0;		// 

//  -   . . rtc.c
extern flash byte MonthDayTable [ 12 ];

//    . 0 - , 1 - 
volatile bit powerOn;
            
//   .   rtc.c
//  == 0 - 
//  == 1 - 
volatile bit secondsPointFlag = 0; 

byte corrFlags;		// ,  . . CORR_XXX

//  
byte alarmOn;	       		//   (on/off)
byte alarmSignalActive;         //    

/////////////////////////////////////////////////////////////////////////////
// ,   . 13 .
volatile byte outString [14];
                         
//            
// - 
#define DECODER_CH_COUNT	20

//  
flash byte chars [ DECODER_CH_COUNT ] = {
		'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 	// idx 0 - 9
		' ', 'A', 'C', 'b', '-', 'l', 'd', 'o', 'r', 'Y'		// 10 - 18
                			};
flash byte segmValues [ DECODER_CH_COUNT ] = {
		0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F, // '0' - '9'
             //  ' '   'A'   'C'   'b'   '-'   'l'   'd'   'o'   'r'   'Y'
                0x00, 0x77, 0x39, 0x7C, 0x40, 0x30, 0x5E, 0x5C, 0x50, 0x6E
                				};                        
//    () 
//    0..12.  4     (PORTD.0 .. PORTD.3)
volatile byte dcValue = 0; 

//              
volatile word pointFlags = 0;
//  
volatile word pointMask = 1;
/////////////////////////////////////////////////////////////////////////////

// Timer 0 overflow interrupt service routine   
// 1 ms
interrupt [TIM0_OVF] void timer0_ovf_isr ( void )
{
 byte segmentsValue;	//    
 char tStringSymbol;   		//   
 byte i, pd;

 // Reinitialize Timer 0 value
 TCNT0 = 0x83;
 
 // Place your code here
 ms ++;

 //  
 tStringSymbol = outString [ dcValue ];
 //    
 for ( i = 0; i < DECODER_CH_COUNT; i ++ )
 {
  if ( tStringSymbol == chars [ i ] )
   break;
 } // for

 // i -   
 if ( i == DECODER_CH_COUNT )	//   
  segmentsValue = segmValues [ 10 ];	// 
 else		// ,    
  segmentsValue = segmValues [ i ];    
 
 // 
 if ( ( pointFlags & pointMask ) != 0 )
  segmentsValue |= 0x80;
  
 //     
 PORTC = segmentsValue;      		// 

 // .   (PORTD.0 .. PORTD.3)
 pd = PORTD & 0xF0;
 PORTD = pd | dcValue;

 //    
 dcValue ++;
 pointMask <<=1;
   
 //     -  
 if ( dcValue == 13  )
 {
  dcValue = 0;
  pointMask = 1;
 } // if                                
} // timer0_ovf_isr

// Timer 2 overflow interrupt - rtc.c	

void main ( void )
{
 // Declare your local variables here
 RtcTimeType time;
 byte viewMode = MODE_1;	// ,    . . MODE_XXX  
 byte prevViewMode;		//          
 byte daysInMonth;		//   
 dword lastKeyTime = 0;
 dword blinkingTime = 0;
 byte isShowSpace = 0;		//      :
 				//   

 cpuInit ( );
 rtcInit ( );

 //    
 alarmOn = 0; 

 //    
 corrFlags = 0;

 //   
 pointFlags = 0;    
             
 //   
 powerOn = 1;
                                         
// BEEPER_PIN = 1;
 memset ( outString, 0, sizeof ( outString ) );   
 strcpyf ( outString, "- 4ACbl -" );
 ALARM_LED = 1;
 delay_ms ( 500 ); 
 ALARM_LED = 0;
 delay_ms ( 500 ); 
 ALARM_LED = 1;
 delay_ms ( 250 ); 
 ALARM_LED = 0;
// BEEPER_PIN = 0;
 
 while ( 1 )
 {                           
  //  
  while ( NO_POWER_PIN == 1 )
  { //   ,        
   //    
   timer0off ( );

   //       pull-up
   PORTA = 0x00;
   DDRA = 0x00;

   PORTB = 0x00;
   DDRB = 0x00;

   PORTC = 0x00;
   DDRC = 0x00;

   PORTD = 0x00;        // pullup   PD6
   DDRD = 0x00;		//  
 
   //   E   PE0 - NO_POWER_PIN
   PORTE = 0x01;        // pullup   PE0
   DDRE = 0x00;

   //                                          
   powerOn = 0;

   //    
   corrFlags = 0;

   //    Power- Save: SM2..SM0 = 011
   //  SM0 := 1 - bit 7 in EMCUCR
   //  SM1 := 1 - bit 4 in MCUCR
   //  SM2 := 0 - bit 5 in MCUCSR
   //   SE := 1 - bit 5 in MCUCR  
   //  : MCUCR |= 00110000 = 0x30; MCUCSR &= 11011111 = 0xDF; EMCUCR |= 0x80
   MCUCR |= 0x30;
   MCUCSR &= 0xDF;
   EMCUCR |= 0x80;
   
   #asm ( "sei" );
   #asm ( "sleep" );	// 
  } // while

  if ( powerOn == 0 )
  { //   ,  
   //  
   MCUCR &= 0x0F;
 
   //  
   portsInit ( );	//   

   //    
   timer0Init ( );

   //                                          
   powerOn = 1;
/*
   ALARM_LED = 1;
   delay_ms ( 500 ); 
   ALARM_LED = 0;
   delay_ms ( 500 ); 
   ALARM_LED = 1;
   delay_ms ( 250 ); 
   ALARM_LED = 0;
*/
  } // if
  
  // 
  if ( alarmOn == 1 && time.alarm_hour == time.hours && time.alarm_minute == time.minutes )
  { //      
   alarmSignalActive = 1;
   BEEPER_PIN = 1;	//     
  } // if
  else
  { //  
   alarmSignalActive = 0;
   BEEPER_PIN = 0;	//     
  } // else

  // 
  if ( corrFlags == 0 )	//    
  {
   rtcGetTime ( &time );                  //   

   // 
   switch ( viewMode )
   {
    case MODE_1:		//  1: "DD.MM hh-mm-ss"
     sprintf ( outString, "%02d%02d %02d-%02d-%02d",
     		time.day, time.month, time.hours, time.minutes, time.seconds );

     //    1 ( DD)
     pointFlags = 0x0002;
     break;
   
    case MODE_2:		//  2: "DD d hh-mm-ss"
     sprintf ( outString, "%02d %d %02d-%02d-%02d", time.day, time.dayOfWeak,
     		time.hours, time.minutes, time.seconds );
     //  
     pointFlags = 0x0000;
     break;

    case MODE_3:		//  3: "DD.MM d hh-mm "  
     if ( secondsPointFlag == 1 )
      sprintf ( outString, "%02d%02d %d %02d-%02d", time.day, time.month, time.dayOfWeak,
      		 time.hours, time.minutes );
     else
      sprintf ( outString, "%02d%02d %d %02d %02d", time.day, time.month, time.dayOfWeak,
      		 time.hours, time.minutes );

     //    1
     pointFlags = 0x0002;	//   
     break;

    case MODE_4:		//  4: "DD.MM.d.hh-mm-ss"
     sprintf ( outString, "%02d%02d%d%02d-%02d-%02d", time.day, time.month, time.dayOfWeak,
     		time.hours, time.minutes, time.seconds );
     pointFlags = 0x001A;	//    1, 3  4
     break;           
     
    case MODE_5:		//  5: "DD.MM.YYYY hh.mm"  
     sprintf ( outString, "%02d%02d%04d %02d%02d", time.day, time.month, time.year,
     		time.hours, time.minutes );
     if ( secondsPointFlag == 1 )
      pointFlags = 0x040A;	//    1, 3  10
     else
      pointFlags = 0x000A;	//    1, 3
     break;                                   
     
    case MODE_6:		//  6: "d  hh - mm"  
//     memset ( outString, 0, sizeof ( outString ) );   
     sprintf ( outString, "6Yd  %02d - %02d", time.alarm_hour, time.alarm_minute );
     pointFlags = 0x0000;	//  
     break;
   } // switch
  } // if  
  else
  { // 
   if ( ms - blinkingTime > 100 )
   { //    -  /
    isShowSpace = 1 - isShowSpace;                           
    blinkingTime = ms;
   } // if                       
   
   // 
   switch ( corrFlags )
   {
    case CORR_CLOCK_SEC:	//  
     pointFlags = 0x0000;	//  
     if ( isShowSpace )
      sprintf ( outString, "Corr %02d-%02d-  ", time.hours, time.minutes, time.seconds );
     else
      sprintf ( outString, "Corr %02d-%02d-%02d", time.hours, time.minutes, time.seconds );
     break;

    case CORR_CLOCK_MIN:	//  
     pointFlags = 0x0000;	//  
     if ( isShowSpace )
      sprintf ( outString, "Corr %02d-  -%02d", time.hours, time.seconds );
     else
      sprintf ( outString, "Corr %02d-%02d-%02d", time.hours, time.minutes, time.seconds );
     break;

    case CORR_CLOCK_HOUR:	//  
     pointFlags = 0x0000;	//  
     if ( isShowSpace )
      sprintf ( outString, "Corr   -%02d-%02d", time.minutes, time.seconds );
     else
      sprintf ( outString, "Corr %02d-%02d-%02d", time.hours, time.minutes, time.seconds );
     break;

    case CORR_CALENDAR_DAY:	//  
     pointFlags = 0x0140;	//    7  9
     if ( isShowSpace )
      sprintf ( outString, "Corr   %02d%04d", time.month, time.year );
     else
      sprintf ( outString, "Corr %02d%02d%04d", time.day, time.month, time.year );
     break;

    case CORR_CALENDAR_MONTH:	//  
     pointFlags = 0x0140;	//    7  9
     if ( isShowSpace )
      sprintf ( outString, "Corr %02d  %04d", time.day, time.year );
     else
      sprintf ( outString, "Corr %02d%02d%04d", time.day, time.month, time.year );
     break;

    case CORR_CALENDAR_YEAR:	//  
     pointFlags = 0x0140;	//    7  9
     if ( isShowSpace )
      sprintf ( outString, "Corr %02d%02d    ", time.day, time.month );
     else
      sprintf ( outString, "Corr %02d%02d%04d", time.day, time.month, time.year );
     break;

    case CORR_ALARM_MIN:	//   
     pointFlags = 0x0018;	// 
     if ( isShowSpace )
      sprintf ( outString, "Corr6 %02d -  ", time.alarm_hour );
     else
      sprintf ( outString, "Corr6 %02d - %02d", time.alarm_hour, time.alarm_minute );
     break;

    case CORR_ALARM_HOUR:	//   
     pointFlags = 0x0018;	// 
     if ( isShowSpace )
      sprintf ( outString, "Corr6    - %02d", time.alarm_minute );
     else
      sprintf ( outString, "Corr6 %02d - %02d", time.alarm_hour, time.alarm_minute );
     break;

   } // switch corrFlags       
  } // else - 

  //   
  if ( ms - lastKeyTime > 250 )
  {
   if ( BUTTON_MODE == 0 )
   { //                       
    lastKeyTime = ms;

    if ( corrFlags == 0 )
    { //  
     viewMode <<= 1;
     if ( viewMode > MODE_5 )
      viewMode = MODE_1;
    } // if
    else
    { // 
     switch ( corrFlags )
     {
      case CORR_CLOCK_SEC:	//  
      case CORR_CLOCK_MIN:	//  
      case CORR_CLOCK_HOUR:	//  
       corrFlags = CORR_CALENDAR_DAY;
       break;
    
      case CORR_CALENDAR_DAY:	//  
      case CORR_CALENDAR_MONTH:	//  
      case CORR_CALENDAR_YEAR:	//  
       corrFlags = CORR_ALARM_HOUR;
       break;

      case CORR_ALARM_HOUR:	//   
      case CORR_ALARM_MIN:	//   
       corrFlags = CORR_CLOCK_HOUR;
       break;
     } // switch corrFlags    
    } // else
   } // if BUTTON_MODE

   if ( BUTTON_CORR == 0 )
   { // /   
    lastKeyTime = ms;
    if ( corrFlags == 0 )	
    { //  
     corrFlags = CORR_CLOCK_HOUR;
    } // if
    else
    { //  
     corrFlags = 0;             
    } // else
   } // if BUTTON_CORR

   if ( BUTTON_DOWN == 0 )
   { //   
    lastKeyTime = ms;

    switch ( corrFlags )
    {
     case CORR_CLOCK_SEC:	//  
      time.seconds = 0;
     break;

     case CORR_CLOCK_MIN:	//  
      time.minutes --;
      if ( time.minutes == 255 ) 
       time.minutes = 59;
      break;

     case CORR_CLOCK_HOUR:	//  
      time.hours --;
      if ( time.hours == 255 )
       time.hours = 23;
      break;

     case CORR_CALENDAR_DAY:	//  
      pointFlags = 0x0014;	//    3  5
      daysInMonth = MonthDayTable [ time.month - 1 ];	// -   
      if ( time.month == 2 && isLeapYear ( time.year ) != 0 )
       daysInMonth ++;		//     29 

      time.day --;   
      if ( time.day == 0 )
       time.day = daysInMonth;
      break;

     case CORR_CALENDAR_MONTH:	//  
      pointFlags = 0x0014;	//    3  5
      time.month --;
      if ( time.month == 0 )
       time.month = 12;
      break;

     case CORR_CALENDAR_YEAR:	//  
      pointFlags = 0x0014;	//    3  5
      time.year --;
      break;

     case CORR_ALARM_MIN:	//   
      time.alarm_minute --;
      if ( time.alarm_minute == 255 ) 
       time.alarm_minute = 59;
      break;

     case CORR_ALARM_HOUR:	//   
      time.alarm_hour --;
      if ( time.alarm_hour == 255 )
       time.alarm_hour = 23;
      break;
    } // switch corrFlags
   } // if BUTTON_DOWN

   if ( BUTTON_UP == 0 )
   { //   
    lastKeyTime = ms;         

    switch ( corrFlags )
    {
     case 0:			//  ,        
      if ( viewMode != MODE_6 )
      {
       prevViewMode = viewMode;
       viewMode = MODE_6;	//  
      } // if
      break;
      
     case CORR_CLOCK_SEC:	//  
      time.seconds = 0;
      break;

     case CORR_CLOCK_MIN:	//  
      time.minutes ++;
      if ( time.minutes == 60 ) 
       time.minutes = 0;
      break;

     case CORR_CLOCK_HOUR:	//  
      time.hours ++;
      if ( time.hours == 24 )
       time.hours = 0;
      break;

     case CORR_CALENDAR_DAY:	//  
      pointFlags = 0x0014;	//    3  5
      daysInMonth = MonthDayTable [ time.month - 1 ];	// -   
      if ( time.month == 2 && isLeapYear ( time.year ) != 0 )
       daysInMonth ++;		//     29 
           
      time.day ++;
      if ( time.day > daysInMonth )
       time.day = 1;
      break;

     case CORR_CALENDAR_MONTH:	//  
      pointFlags = 0x0014;	//    3  5
      time.month ++;
      if ( time.month == 13 )
       time.month = 1;
      break;

     case CORR_CALENDAR_YEAR:	//  
      pointFlags = 0x0014;	//    3  5
      time.year ++;
      break;

     case CORR_ALARM_MIN:	//   
      time.alarm_minute ++;
      if ( time.alarm_minute == 60 ) 
       time.alarm_minute = 0;
      break;

     case CORR_ALARM_HOUR:	//   
      time.alarm_hour ++;
      if ( time.alarm_hour == 24 )
       time.alarm_hour = 0;
      break;
    } // switch corrFlags
   } // if BUTTON_UP
   else
   { //   
    if ( viewMode == MODE_6 )
     viewMode = prevViewMode;
   } // else
   
   if ( BUTTON_SET == 0 )
   { // 
    lastKeyTime = ms;          
    
    if ( corrFlags == 0 )
    { //  ,  
      alarmOn = 1 - alarmOn;
      if ( alarmOn == 0 )
       ALARM_LED = 0;
      else
       ALARM_LED = 1;

      continue;
    } // if

    //   
    // 
    rtcSetTime ( time );

    //       
    switch ( corrFlags )
    {
     case CORR_CLOCK_SEC:	//  
      corrFlags = CORR_CLOCK_HOUR;
      break;

     case CORR_CLOCK_MIN:	//  
      corrFlags = CORR_CLOCK_SEC;
      break;

     case CORR_CLOCK_HOUR:	//  
      corrFlags = CORR_CLOCK_MIN;
      break;

     case CORR_CALENDAR_DAY:	//  
      corrFlags = CORR_CALENDAR_MONTH;
      break;

     case CORR_CALENDAR_MONTH:	//  
      corrFlags = CORR_CALENDAR_YEAR;
      break;

     case CORR_CALENDAR_YEAR:	//  
      corrFlags = CORR_CALENDAR_DAY;
      break;
 
     case CORR_ALARM_MIN:	//   
      corrFlags = CORR_ALARM_HOUR;
      break;

     case CORR_ALARM_HOUR:	//   
      corrFlags = CORR_ALARM_MIN;
      break;
   } // switch corrFlags    
   } // if BUTTON_SET

  } // if   
 } // while
} // main

void cpuInit ( void )
{
 // Crystal Oscillator division factor: 1
 CLKPR = 0x80;
 CLKPR = 0x00;

 portsInit ( );                         
 
 //    
 timer0Init ( );

 // Timer/Counter 1 initialization
 // Clock source: System Clock
 // Clock value: Timer 1 Stopped
 // Mode: Normal top=FFFFh
 // OC1A output: Discon.
 // OC1B output: Discon.
 // Noise Canceler: Off
 // Input Capture on Falling Edge
 TCCR1A = 0x00;
 TCCR1B = 0x00;
 TCNT1H = 0x00;
 TCNT1L =0x00;
 ICR1H = 0x00;
 ICR1L = 0x00;
 OCR1AH = 0x00;
 OCR1AL = 0x00;
 OCR1BH = 0x00;
 OCR1BL = 0x00;

 // Timer/Counter 2 initialization
 // Clock source: TOSC1 pin
 // Clock value: PCK2/8
 // Mode: Normal top=FFh
 // OC2 output: Disconnected
 ASSR = 0x08;
// TCCR2 = 0x02;       	// CS22..20 = 010: f = PCK2/8 = 32768/8 = 4.096 kHz
 TCCR2 = 0x04;	       	// CS22..20 = 100: f = PCK2/64 = 32768/64 = 512 Hz
 TCNT2 = 0x00;		// 512 / 256 = 2
 OCR2 = 0x00;

 // Timer/Counter 3 initialization
 // Clock value: Timer 3 Stopped
 // Mode: Normal top=FFFFh
 // Noise Canceler: Off
 // Input Capture on Falling Edge
 // OC3A output: Discon.
 // OC3B output: Discon.
 TCCR3A = 0x00;
 TCCR3B = 0x00;
 TCNT3H = 0x00;
 TCNT3L = 0x00;
 ICR3H = 0x00;
 ICR3L = 0x00;
 OCR3AH = 0x00;
 OCR3AL = 0x00;
 OCR3BH = 0x00;
 OCR3BL = 0x00;

 // External Interrupt(s) initialization
 // INT0: Off
 // INT1: Off
 // INT2: Off
 // Interrupt on any change on pins PCINT0-7: Off
 // Interrupt on any change on pins PCINT8-15: Off
 MCUCR = 0x00;
 EMCUCR = 0x00;

 // Timer(s)/Counter(s) Interrupt(s) initialization
 TIMSK = 0x06;
 ETIMSK = 0x00;

 // Analog Comparator initialization
 // Analog Comparator: Off
 // Analog Comparator Input Capture by Timer/Counter 1: Off
 // Analog Comparator Output: Off
 ACSR = 0x80;		// bit 7 = 1 - Comparator off
 
 // USART off

 // Global enable interrupts
 #asm("sei")
} // cpuInit

void portsInit ( void )
{
 // Input/Output Ports initialization
 // Port A initialization
 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
 PORTA = 0x00;
 DDRA = 0x00;

 // Port B initialization
 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
 // State7=T State6=T State5=T State4=P State3=P State2=P State1=P State0=P 
 PORTB=0x1F;
 DDRB=0x00;
// PINB = 0x1F;

 // Port C initialization
 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
 PORTC = 0x00;
 DDRC = 0xFF;
 
 // Port D initialization
 // Func7=Out Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
 // State7=0 State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
 PORTD = 0x00; 
 DDRD = 0x8F;

 // Port E initialization
 // Func2=Out Func1=In Func0=In
 // State2=0 State1=T State0=P 
 PORTE = 0x01;
 DDRE = 0x04;
} // portsInit

//     
void timer0Init ( void )
{
 // Timer/Counter 0 initialization
 // Clock source: System Clock
 // Clock value: 125,000 kHz
 // Mode: Normal top=FFh
 // OC0 output: Disconnected
 TCCR0 = 0x03; 		// 00000011: CS02..CS00 = 011: CLK/64 = 8 MHz/64 = 125 kHz
 TCNT0 = 0x83;		// Divider = 256 - 0x83 = 125
 OCR0 = 0x00;
} // timer0Init
              
//    
void timer0off ( void )
{
 TCCR0 = 0x00; 		// 00000000: CS02..CS00 = 000: stop
} // timer0off
