// rtc.c
//    

#include <mega162.h>
#include <string.h>

#include "rtc.h"
	
#define ALARM_LED		PORTD.7 
                           
//   
// 0 - 
// 1 - 
extern volatile bit secondsPointFlag;

//    . 0 - , 1 - 
extern volatile bit powerOn;

//  -   .
flash byte MonthDayTable [ 12 ] = { 31,28,31,30,31,30,31,31,30,31,30,31 };

// Global variables
// time registers
static RtcTimeType RtcTime;

// -                      
//volatile bit alarmSecFlag = 0;            

extern byte corrFlag;		// ,  . . CORR_XXX

//   
static byte dayOfWeak ( byte day, byte month, word year );

//   2.  2   
interrupt [TIM2_OVF] void timer2_ovf_isr ( void )
{
 // Place your code here
 byte daysInMonth;		//   

 // update real-time clock registers
 RtcTime.tics ++;        

 if ( powerOn == 1 )
 { //   
  //    
  secondsPointFlag = ~secondsPointFlag;
 } // if   

 //    
 if ( RtcTime.tics % 2 == 0 )
 { // 1 sec
  RtcTime.seconds ++;	     		// increment seconds
  if ( RtcTime.seconds > 59 )		// check seconds overflow
  {
   RtcTime.seconds = 0;
   RtcTime.minutes ++;	     		// increment minutes
   if ( RtcTime.minutes > 59 )		// check minutes overflow
   {
    RtcTime.minutes -= 60;
    RtcTime.hours ++;					// increment hours
    if ( RtcTime.hours > 23 )
    { //  ,  
     RtcTime.hours = 0;
     RtcTime.day ++;					// increment days

     // check days overflow
     daysInMonth = MonthDayTable [RtcTime.month-1];
     if ( RtcTime.month == 2 && isLeapYear ( RtcTime.year ) != 0 )
      daysInMonth ++;		//     29 

     if ( RtcTime.day > daysInMonth )
     {
      RtcTime.day = 1;
      RtcTime.month ++;			// increment months
      
      if ( RtcTime.month == 13 )	// check months overflow
      {
       RtcTime.month = 1;
       RtcTime.year ++;			// increment years
      } // if month == 13
     } // if days > daysInMonth

     //   
     RtcTime.dayOfWeak = dayOfWeak ( RtcTime.day, RtcTime.month, RtcTime.year );    
    } // if hours > 23
   } // if minutes > 59
  } // if seconds > 59      
 } // if 1 sec
} // timer2_ovf_isr

//  
void rtcInit ( void )
{               
 memset ( &RtcTime, 0, sizeof ( RtcTime ) );
 RtcTime.year = 2000;         
 RtcTime.month = 1;
 RtcTime.day = 1;

 //   
 RtcTime.dayOfWeak = dayOfWeak ( RtcTime.day, RtcTime.month, RtcTime.year );    
} // rtcInit

//   
void rtcGetTime ( RtcTimeType *pTime )
{                                     
 memcpy ( pTime, &RtcTime, sizeof ( RtcTime ) );
} // rtcGetTime

//   
void rtcSetTime ( RtcTimeType time )
{               
 #asm ( "cli" );
 memcpy ( &RtcTime, &time, sizeof ( RtcTime ) );
 //   
 RtcTime.dayOfWeak = dayOfWeak ( RtcTime.day, RtcTime.month, RtcTime.year );    
 #asm ( "sei" );
} // rtcSetTime

//     
byte isLeapYear ( word year )
{
 if ( year % 4 == 0 )
  return 1;

 return 0;
} // isLeapYear

//   
byte dayOfWeak ( byte d, byte m, word y )
{
 byte w, j, c;

 if ( m < 3 )
 {
  m += 12;
  y --;
 } // if
 j = y % 100;
 c = y / 100;
 w = ( d + 13 * ( m + 1 ) / 5 + j + j / 4 - 2 * c + c / 4 - 1 ) % 7;
 if ( w < 0 )
  w += 7;
      
 //    0,   7
 if ( w == 0 )
  w = 7;
  
 return w;
} // dayOfWeak